//+------------------------------------------------------------------+
//|                                                     OB ident.mq4 |
//+------------------------------------------------------------------+
//http://www.forexfactory.com/showpost.php?p=2533293&postcount=2
//by hanover Feb 12, 2009   
 
  
 

#property indicator_chart_window

extern double   MinBarHeight       = 150;
extern double   MaxBarHeight       = 1500;
extern double   CloseWithinXpct    = 25;
extern double   MinBodyPct         = 25;
extern bool     MustFollowOppColor = false;
extern int      EngulfMarginPct    = 100;
extern int      EngulfTolerance    = 20;
extern int      StartHour          = 0;
extern int      EndHour            = 23;

string   ccy;
int      dig, spr, tf;
double   pnt;
datetime prev_time;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()  {

  ccy = Symbol();
  tf  = Period();
  pnt = MarketInfo(ccy,MODE_POINT);
  dig = MarketInfo(ccy,MODE_DIGITS);
  spr = MarketInfo(ccy,MODE_SPREAD);

//  Comment("pnt=" + pnt + "    dig=" + dig + "    spr=" + spr);

  del_obj();
  plot_obj();    
  prev_time = -9999;
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()  {
  del_obj();
  return(0);
}
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
  if(prev_time != Time[0])  {
    del_obj();
    plot_obj();    
  }  
  prev_time = Time[0];
  return(0);
}

//+------------------------------------------------------------------+
void del_obj()   {
  for(int i=ObjectsTotal()-1; i>=0; i--)  {
    string objname = ObjectName(i);
    if (ObjectType(objname) == OBJ_ARROW && StringSubstr(objname,0,4) == "obid")   ObjectDelete(objname);
  }  
  return(0);
} 

//+------------------------------------------------------------------+
void plot_obj()   {

  int valid;
  for (int i=1; i<=Bars-1; i++)  {
    int hr = TimeHour(Time[i]);
    if (hr < StartHour || hr > EndHour)  continue;
    bool OutsideBar = true;
    if (High[i] < High[i+1] || Low[i] > Low[i+1])   OutsideBar = false;                                // not an OB

    bool EngulfBody = true;
    if (EngulfTolerance < 0)   
      EngulfBody = false;
    else  {
      double HiOCcurr = MathMax(Open[i], Close[i]);
      double LoOCcurr = MathMin(Open[i], Close[i]);
      double HiOCprev = MathMax(Open[i+1], Close[i+1]);
      double LoOCprev = MathMin(Open[i+1], Close[i+1]);
      if ((HiOCcurr - LoOCcurr) < (HiOCprev - LoOCprev) * EngulfMarginPct /100 )   EngulfBody = false;                                                // not an engulfing body
      if (HiOCcurr < HiOCprev - EngulfTolerance*pnt || LoOCcurr > LoOCprev + EngulfTolerance*pnt)  EngulfBody = false;    // not an engulfing body
      if (Close[i] > Open[i] && High[i] < High[i+1])   EngulfBody = false;                                                // green bar whose high lower than prev high
      if (Close[i] < Open[i] && Low[i]  > Low[i+1])    EngulfBody = false;                                                // red bar whose low higher than prev low
    }  

    if (!OutsideBar && !EngulfBody)   continue;
    if (High[i] - Low[i] < MinBarHeight*pnt || High[i] - Low[i] > MaxBarHeight*pnt)  continue;         // bar length outside max or min
    if (MathAbs(Close[i] - Open[i]) / (High[i] - Low[i]) < MinBodyPct / 100)  continue;                // body not at least X% of candle height
    
    if (Close[i] > Open[i])  {                                                                         // green bar 
      if (!MustFollowOppColor || Close[i+1] < Open[i+1])  {                                            // must be preceded by red bar
        if ((High[i] - Close[i]) / (High[i] - Low[i]) <= CloseWithinXpct / 100)  {                     // close within X% of top of candle
          ObjectCreate("obidl"+i,OBJ_ARROW,0,iTime(ccy,tf,i),iLow(ccy,tf,i)-50*pnt);
          ObjectSet("obidl"+i,OBJPROP_ARROWCODE,241);
          ObjectSet("obidl"+i,OBJPROP_COLOR,White);
          ObjectSet("obidl"+i,OBJPROP_WIDTH,1);
          valid = 0;
          if (High[i+2]  >  High[i+1])  valid += 2;
          if (High[i+3]  >  High[i+2])  valid += 1;
          if (High[i+4]  >= High[i+3])  valid += 1;
          if (High[i+5]  >= High[i+4])  valid += 1;
          if (High[i+10] >  High[i+1])  valid += 1;
          if (valid >= 5)  ObjectSet("obidl"+i,OBJPROP_WIDTH,4);
          if (!OutsideBar) ObjectSet("obidl"+i,OBJPROP_COLOR,Yellow);
    } } }    
    
    if (Close[i] < Open[i])  {                                                                          // red bar
      if (!MustFollowOppColor || Close[i+1] > Open[i+1])  {                                             // must be preceded by green bar
        if ((Close[i] - Low[i]) / (High[i] - Low[i]) <= CloseWithinXpct / 100)  {                       // close within X% of bottom of candle
          ObjectCreate("obidh"+i,OBJ_ARROW,0,iTime(ccy,tf,i),iHigh(ccy,tf,i)+200*pnt);
          ObjectSet("obidh"+i,OBJPROP_ARROWCODE,242);
          ObjectSet("obidh"+i,OBJPROP_COLOR,White);
          ObjectSet("obidh"+i,OBJPROP_WIDTH,1);
          valid = 0;
          if (Low[i+2]  <  Low[i+1])  valid += 2;
          if (Low[i+3]  <  Low[i+2])  valid += 1;
          if (Low[i+4]  <= Low[i+3])  valid += 1;
          if (Low[i+5]  <= Low[i+4])  valid += 1;
          if (Low[i+10] <  Low[i+1])  valid += 1;
          if (valid >= 5)  ObjectSet("obidh"+i,OBJPROP_WIDTH,4);
          if (!OutsideBar) ObjectSet("obidh"+i,OBJPROP_COLOR,Yellow);
    } } }    
  }
  return(0);
} 

/*
//hanover Feb 12, 2009   
//http://www.forexfactory.com/showpost.php?p=2533293&postcount=2


The attached indicator - which I wrote a long time ago - will highlight OBs (and much more), but somebody will need to add an alert to it.
It plots white arrows to highlight outside bars (higher high, lower low than preceding candle), and optionally also yellow arrows for other candles whose body engulfs the previous candle's body. It can be attached to an MT4 chart of any pair, any timeframe. You can attach it to multiple chart timeframes if you wish.
The parameters work as follows:
MinBarHeight, MaxBarHeight - candles whose height (in points) falls outside this range will not be highlighted.
CloseWithinXpct - the close must be within the top X% of the candle, for a bullish candle, and in the bottom X% for a bearish candle. Set to 100 if this doesn't matter.
MinBodyPct - the body must be at least X% of the total candle height. Set to 0 if this doesn't matter.
MustFollowOppColor - set to true if the OB must be of opposite color to the candle that it engulfs. Set to false if this doesn't matter.
EngulfMarginPct - applies to engulfing body candles only, as opposed to OBs. The body must be at least X% in height, relative to the height of the previous candle's body. e.g. if the body must be at least twice as high, enter 200.
EngulfTolerance - applies to engulfing body candles only, as opposed to OBs. Allows a tolerance of X points between the close of the previous candle, and the open of the current candle. Setting this to a negative value means that only OBs, as opposed to engulfing body candles, will be highlighted (i.e. no yellow arrows on the chart).
StartHour, EndHour - Candles falling outside this time range will not be highlighted.
Difference between the larger and smaller arrows: This is a very rough attempt to highlight (with larger arrows) OBs/engulfing bodies that occur at the end of a trend (signaling a possible reversal), or during a pullback (signaling a possible continuation of the original trend).
*/